## ros-crystal-composition 0.6.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(composition)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(class_loader REQUIRED)
find_package(example_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_cmake REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(std_msgs REQUIRED)

rosidl_generate_interfaces(${PROJECT_NAME}
  "srv/LoadNode.srv"
)

include_directories(include)

# create ament index resource which references the libraries in the binary dir
set(node_plugins "")

add_library(talker_component SHARED
  src/talker_component.cpp)
target_compile_definitions(talker_component
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(talker_component
  "class_loader"
  "rclcpp"
  "std_msgs")
rclcpp_register_node_plugins(talker_component "composition::Talker")
set(node_plugins "${node_plugins}composition::Talker;$<TARGET_FILE:talker_component>\n")

add_library(listener_component SHARED
  src/listener_component.cpp)
target_compile_definitions(listener_component
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(listener_component
  "class_loader"
  "rclcpp"
  "std_msgs")
rclcpp_register_node_plugins(listener_component "composition::Listener")
set(node_plugins "${node_plugins}composition::Listener;$<TARGET_FILE:listener_component>\n")

add_library(server_component SHARED
  src/server_component.cpp)
target_compile_definitions(server_component
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(server_component
  "class_loader"
  "example_interfaces"
  "rclcpp")
rclcpp_register_node_plugins(server_component "composition::Server")
set(node_plugins "${node_plugins}composition::Server;$<TARGET_FILE:server_component>\n")

add_library(client_component SHARED
  src/client_component.cpp)
target_compile_definitions(client_component
  PRIVATE "COMPOSITION_BUILDING_DLL")
ament_target_dependencies(client_component
  "class_loader"
  "example_interfaces"
  "rclcpp")
rclcpp_register_node_plugins(client_component "composition::Client")
set(node_plugins "${node_plugins}composition::Client;$<TARGET_FILE:client_component>\n")

# since the package installs libraries without exporting them
# it needs to make sure that the library path is being exported
if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}")
endif()

add_executable(manual_composition
  src/manual_composition.cpp)
target_link_libraries(manual_composition
  talker_component
  listener_component
  server_component
  client_component)
ament_target_dependencies(manual_composition
  "rclcpp")

add_executable(linktime_composition
  src/linktime_composition.cpp)
set(libs
  talker_component
  listener_component
  server_component
  client_component)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(libs
    "-Wl,--no-as-needed"
    ${libs}
    "-Wl,--as-needed")
endif()
target_link_libraries(linktime_composition ${libs})
ament_target_dependencies(linktime_composition
  "class_loader"
  "rclcpp")

add_executable(dlopen_composition
  src/dlopen_composition.cpp)
ament_target_dependencies(dlopen_composition
  "class_loader"
  "rclcpp")

add_executable(api_composition
  src/api_composition.cpp)
target_link_libraries(api_composition ament_index_cpp::ament_index_cpp)
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_link_libraries(api_composition "stdc++fs")
endif()
ament_target_dependencies(api_composition
  "class_loader"
  "rclcpp"
  "rcutils")
rosidl_target_interfaces(api_composition
  ${PROJECT_NAME} "rosidl_typesupport_cpp")

add_executable(api_composition_cli
  src/api_composition_cli.cpp)
ament_target_dependencies(api_composition_cli
  "rclcpp")
rosidl_target_interfaces(api_composition_cli
  ${PROJECT_NAME} "rosidl_typesupport_cpp")

install(TARGETS
  talker_component
  listener_component
  server_component
  client_component
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(TARGETS
  manual_composition
  linktime_composition
  dlopen_composition
  api_composition
  api_composition_cli
  DESTINATION lib/${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)
  find_package(rmw_implementation_cmake REQUIRED)

  file(GENERATE
    OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>/share/ament_index/resource_index/node_plugin/${PROJECT_NAME}"
    CONTENT "${node_plugins}")

  set(generated_python_files)
  macro(tests)
    set(MANUAL_COMPOSITION_EXECUTABLE $<TARGET_FILE:manual_composition>)
    set(LINKTIME_COMPOSITION_EXECUTABLE $<TARGET_FILE:linktime_composition>)
    set(DLOPEN_COMPOSITION_EXECUTABLE $<TARGET_FILE:dlopen_composition>)
    set(TALKER_LIBRARY $<TARGET_FILE:talker_component>)
    set(LISTENER_LIBRARY $<TARGET_FILE:listener_component>)
    set(SERVER_LIBRARY $<TARGET_FILE:server_component>)
    set(CLIENT_LIBRARY $<TARGET_FILE:client_component>)
    set(API_COMPOSITION_EXECUTABLE $<TARGET_FILE:api_composition>)
    set(API_COMPOSITION_CLI_EXECUTABLE $<TARGET_FILE:api_composition_cli>)
    set(EXPECTED_OUTPUT_ALL "${CMAKE_CURRENT_SOURCE_DIR}/test/composition_all")
    set(EXPECTED_OUTPUT_PUBSUB "${CMAKE_CURRENT_SOURCE_DIR}/test/composition_pubsub")
    set(EXPECTED_OUTPUT_SRV "${CMAKE_CURRENT_SOURCE_DIR}/test/composition_srv")

    set(test_names
      "test_api_pubsub_composition"
      "test_api_srv_composition"
      "test_api_srv_composition_client_first"
      "test_dlopen_composition"
      "test_linktime_composition"
      "test_manual_composition"
    )
    foreach(test_name IN LISTS test_names)
      configure_file(
        test/${test_name}.py.in
        ${test_name}${target_suffix}.py.genexp
        @ONLY
      )
      file(GENERATE
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${test_name}${target_suffix}_$<CONFIG>.py"
        INPUT "${CMAKE_CURRENT_BINARY_DIR}/${test_name}${target_suffix}.py.genexp"
      )
      ament_add_pytest_test(${test_name}${target_suffix}
        "${CMAKE_CURRENT_BINARY_DIR}/${test_name}${target_suffix}_$<CONFIG>.py"
        ENV RMW_IMPLEMENTATION=${rmw_implementation}
        APPEND_ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>
        APPEND_LIBRARY_DIRS "${append_library_dirs}"
        TIMEOUT 60)
      list(
        APPEND generated_python_files
      "${CMAKE_CURRENT_BINARY_DIR}/${test_name}${target_suffix}_$<CONFIG>.py")
    endforeach()
  endmacro()

  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
  if(WIN32)
    set(append_library_dirs "${append_library_dirs}/$<CONFIG>")
  endif()

  call_for_each_rmw_implementation(tests)

  find_package(ament_cmake_flake8 REQUIRED)
  ament_flake8(
    TESTNAME "flake8_generated_launch"
    # the generated code might contain longer lines for templated types
    MAX_LINE_LENGTH 999
    ${generated_python_files})
endif()

ament_package()

=== debian/changelog ===
ros-crystal-composition (0.6.2-0bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 15 Jan 2019 08:00:00 -0000

ros-crystal-composition (0.6.1-0bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-composition (0.6.0-0bionic) bionic; urgency=high

  * Added semicolons to all RCLCPP and RCUTILS macros. (#278 <https://github.com/ros2/demos/issues/278>)
  * Contributors: Chris Lalancette

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 07 Dec 2018 08:00:00 -0000

ros-crystal-composition (0.5.1-0bionic) bionic; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 28 Jun 2018 07:00:00 -0000

ros-crystal-composition (0.5.0-0bionic) bionic; urgency=high

  * Updated launch files to account for the "old launch" getting renamespaced as ``launch`` -> ``launch.legacy``. (#239 <https://github.com/ros2/demos/issues/239>)
  * Updated to avoid newly deprecated class loader headers. (#229 <https://github.com/ros2/demos/issues/229>)
  * Added a periodic log message while waiting for a service response.
  * Contributors: Dirk Thomas, Michael Carroll, Mikael Arguedas, William Woodall

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 27 Jun 2018 07:00:00 -0000

=== debian/control ===
Source: ros-crystal-composition
Section: misc
Priority: extra
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-crystal-ament-cmake, ros-crystal-ament-cmake-pytest, ros-crystal-ament-index-cpp, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-class-loader, ros-crystal-example-interfaces, ros-crystal-launch, ros-crystal-launch-testing, ros-crystal-rclcpp, ros-crystal-rcutils, ros-crystal-rmw-implementation-cmake, ros-crystal-rosidl-cmake, ros-crystal-rosidl-default-generators, ros-crystal-std-msgs, ros-crystal-ros-workspace, ros-crystal-rmw-connext-cpp, ros-crystal-rmw-fastrtps-cpp, ros-crystal-rmw-implementation, ros-crystal-rmw-opensplice-cpp, ros-crystal-rosidl-typesupport-connext-c, ros-crystal-rosidl-typesupport-connext-cpp, ros-crystal-rosidl-typesupport-opensplice-c, ros-crystal-rosidl-typesupport-opensplice-cpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-composition
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-ament-index-cpp, ros-crystal-class-loader, ros-crystal-example-interfaces, ros-crystal-rclcpp, ros-crystal-rcutils, ros-crystal-rosidl-default-runtime, ros-crystal-std-msgs, ros-crystal-ros-workspace
Description: Examples for composing multiple nodes in a single process.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-composition//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
